package com.guams.review.service;

import com.guams.review.modele.AuthorRepository;
import com.guams.review.modele.dao.Author;
import com.guams.review.service.mapper.Mapper;
import com.guams.review.service.mapper.ReturnableAuthor;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Service
@RequiredArgsConstructor
public class AuthorService
{
    private final Mapper mapper;
    private final AuthorRepository authorRepository;

    public List<ReturnableAuthor> list() {
        return authorRepository.findAll().stream()
                .map(mapper::mapAuthor)
                .toList();
    }

    public Optional<Author> findById(UUID id) {
        return authorRepository.findById(id);
    }

    public ReturnableAuthor insert(Author author) {
        return mapper.mapAuthor(authorRepository.save(author));
    }

    public void delete(Author author) {
        authorRepository.delete(author);
    }
}
